#include<bits/stdc++.h>
using namespace std;

#define int long long 

inline int read(){
	int x=0,f=1;char ch=getchar();
	while(ch<'0'||ch>'9'){if(ch=='-')f=-1;ch=getchar();}
	while(ch>='0'&&ch<='9'){x=x*10+(ch-48);ch=getchar();}
	return x*f;
}

const int maxn=1e3+10;
const int p=998244353;

int tim,id;
int n,m,c,f;

int g[maxn][maxn];
int r[maxn][maxn];
int ans1,ans2;

void add(int &x,int y){
	if(x+y>=p) x=x+y-p;
	else x=x+y;
}

void clear(){
	for(int i=0;i<=n+1;i++){
		for(int j=0;j<=m+1;j++) g[i][j]=r[i][j]=0;
	}
	ans1=ans2=0;
}

signed main(){
	freopen("plant.in","r",stdin);
	freopen("plant.out","w",stdout);
	tim=read(),id=read();
	while(tim--){
		string s;
		n=read(),m=read(),c=read(),f=read();
		clear();
		for(int i=1;i<=n;i++){
			cin>>s;
			int tmp=s.length();
			for(int j=0;j<tmp;j++){
				g[i][j+1]=s[j]-48;
			}
		}
		for(int i=1;i<=n+1;i++) g[i][m+1]=1;
		for(int j=1;j<=m;j++) g[n+1][j]=g[0][j]=1;
		for(int i=1;i<=n;i++){
			for(int j=m;j>=1;j--){
				if(!g[i][j]) r[i][j]=r[i][j+1]+1;
	 		}
		}
		int pre=0,res=0;
		for(int i=1;i<=m;i++){
			pre=0,res=0;
			for(int j=1;j<=n;j++){
				if(!g[j][i]){
					int tmp=0;
					add(ans2,res);
					if(g[j-1][i]) add(res,pre*r[j][i+1]%p);
					else{
						if(!r[j-1][i+1]) add(res,pre*r[j][i+1]%p);
						else{
							tmp=(pre-r[j-1][i+1]+p)%p;
							add(res,tmp*r[j][i+1]%p);
						}
					}
					add(pre,r[j][i+1]);
				}
				else if(g[j][i]){
					pre=0;add(ans1,res);
					res=0;
				}
			}
			add(ans1,res);
		}
		ans1=c*ans1%p;
		ans2=f*ans2%p;
		printf("%lld %lld\n",ans1,ans2);
	}
	return 0;
}